#include <stm32f0xx.h>
#include "gpio-state.hpp"

namespace stm32f072xb
{
	class Gpio
	{
	private:
		volatile uint16_t &_port;
		uint16_t _pin;
		GpioState _state;

	public:
		Gpio(volatile uint16_t &port, uint16_t pin, GpioState state = GpioState::RESET);
		~Gpio();

		GpioState getState();
		void setState(GpioState state);
		void toggle();
	};

}
